# Backup and Recovery
## Overview
Kylin Backup and Recovery Tool is used to backup and restore system or user data.

It supports to create new backup points, and incremental backup based on a backup point; as well as restore the system to the state at the time of a backup, and partial restore retaining user data.

There are three modes: General, Grub backup and restore.

<br>

## General
### System Backup

![Fig 1 system backup-big](image/1.png)


- **New System Backup** -- Backup the whole system except the data that in /backup、/media、/run、/proc、/dev、/sys、/cdrom、/mnt etc.

After selecting "New System Backup", click "Backup" and there will pop up a box allowing users to specify backup device those need to be ignored during backup, as shown in Fig 2.

![Fig 2 system backup device choose -big](image/2.png)

After clicking "Ok" to backup, the system will chech whether the backup partition has enough space for this operation. If no, it will pop up an 
error reporting window; Conversely, it will pop up prompt in turn, as shown in Fig 3/4.
 
![Fig 3 Backup prompt-big](image/3.png)

![Fig 4 Backup prompt-big](image/4.png)

Click "Continue" to create a new backup in the backup partition. During backup, there will show a window as shown in Fig 5. The length of backup time depends on the size of backup contents.

![Fig 5 Backup now -big](image/5.png)

The button "Backup Management" near "Backup" is used to view the state of system backups and delete invalid backups.

![Fig 6 Backup Management-big](image/6.png)

- **Update System Backup** -- Continue backup based on a existed backup.

After selecting this function, there will pop up a window to show all backups. Users can choose one from them.

Incremental backup can be performed on the basis of a failed backup.

### System Restore
System restore can restore the system to its previous backup state. Note: If "retain user data" is not checked, all system data (including user data) will be restored; System restore is to restore the system to the state of a previous backup, which will inevitably delete the data changed after the backup point. Please pay attention to backup important data.

![Fig 7	 system restore-big](image/7.png)

### Data Backup and Data Recovery
- **Data Backup** -- Backup the directories or files specified by user, and the function is similar to system backup. Note:``、$()、;、&amp;、| etc. The symbols that can contain and execute system commands or used for continuous execution of system commands are added to the blacklist, and the name of the directory to be backed up is judged before backup. If the symbols in the blacklist are included, backup is not allowed.

![Fig 8 Data backup-big](image/8.png)

After selecting "New Data Backup", click "Backup" and there will pop up a box allowing users to specify directories or files those need to be backuped. As shown in Fig 9, it will backup the contents in /home/kylin/.

![Fig 9 Specify directories or files -big](image/9.png)

The button "Backup Management" near "Backup" is used to view the state of data backups and delete invalid backups.

- **Update Data Backup** -- Add new data to a existed data backup.

- **Data Recovery** -- Recovery the data to its previous backup state, and the function is similar to system restore.

![Fig 10 Data recovery-big](image/10.png)

The system will restart automatically after recovery is complete.

### Log Records
Record all operations on backup and recovery tool, and the interface as shown in Fig 11. Turn pages by clicking "Up" and "Next" button.

![Fig 11 Log records-big](image/11.png)

### Ghost Image
Install from ghost image means generate an image file from an installed system, and then use this image file to copy the same state system to other computers. To use this function, a backup is needed first.

#### Create Ghost Image
The interface as shown in Fig 12, including some tips.

![Fig 12 Ghost image-big](image/12.png)

Click "Ghost" and there will pop up a window to show all backups. Users select one of them and click "Ok" to start creating, as shown in Fig 13-1/13-2.

(Tips: The architecture in name depends on hardware platform.)

![Fig 13-1 Ghost image select and create-big](image/13-1.png)

![Fig 13-2 Ghost image select and create-big](image/13-2.png)

Image filename is "computer name + architecture + backup name.kyimg", and only numbers in the backup name are retained.

#### Install from Ghost Image
1) Copy the ghost image (saved in /ghost) to U-disk or other removable storage device.

2) Enter livecd system and insert the removable device.

3) If it doesn't mount automatically, users can manually mount device through terminal:

sudo mount /dev/sdb1 /mnt

Removable device is /dev/sdb1 by general, and it can be seen by command "fdisk -l".

4) Double click the install button to start installation guide. Select "Install from ghost image" in Installation Type, and find the ghost image in the removable device, as shown in Fig 14. The follow-up steps can refer to installation manual.

(Tips: The architecture in name depends on hardware platform.)

![Fig 14 Ghost install-big](image/14.png)

If there exists data partition when creating ghost image file, it needs to check "Create Data Partition" in the next step.

<br>

## Grub Backup and Recovery

(Tips: The date and time in the figure is for reference only.)

1) Select "Backup and Restore" in grub menu when start-up.

2) Backup or restore are both allowed to select here. If there is an error, restart the system and try again.

- Backup mode: The system will start to backup immediately and the prompt will display on the screen.

For backup mode, is smilar to "Whole Disk Backup" in general mode. If there is no enough space, the backup will fail.

- Restore mode: The system will start to restore to the lastest successful backup state, and the prompt will display on the screen.

For restore mode, is smilar to "Disk Restore" in general mode. If there is no successful backup, the system will not be restored.

<br>

## Q&A
### Can not use backup and recovery tool
In order to use this tool, "Create Backup Partition" must be checked when install system.

<br>

### Backup data/backup partition is allowed?
The contents in data partition are not important to system and have a large capacity, so it's not necessary to backup /data, you can only do factory-backup and some data backup.

Backup partition is used to save and recovery other partitions data, so /backup is not allowed to be backuped or restored.
